package com.handheldgroup.androdirector;

import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        findViewById(R.id.ButtonGetVersionString).setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                startActivity(new Intent(MainActivity.this, GetVersionStringActivity.class));
            }
        });

        findViewById(R.id.ButtonSearchTag).setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                startActivity(new Intent(MainActivity.this, SearchTagActivity.class));
            }
        });

        findViewById(R.id.ButtonAbout).setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                showAbout();
            }
        });

        findViewById(R.id.ButtonQuit).setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                finish();
            }
        });
    }

    public void showAbout() {
        final Dialog dialog = new Dialog(this);
        dialog.setContentView(R.layout.dialog_about);
        dialog.setTitle("About the App");

        ImageView image = dialog.findViewById(R.id.imageView);
        image.setImageResource(R.mipmap.twn4);

        Button dialogButton = dialog.findViewById(R.id.ButtonAboutClick);
        // if button is clicked, close the custom dialog
        dialogButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dialog.dismiss();
            }
        });

        dialog.show();

    }
}
